#include <iostream>
#include <cstdlib>
#include "ds50daq/DAQ/detail/caen_io.hh"


int main (int argc, char *argv[]) {
  if (argc != 3) {
    std::cerr << "usage: ut_ctl prescale_ls(1-4095) global_run_enable(0/1)" << std::endl;
    exit (1);
  }

  unsigned int prescale_ls = std::atoi (argv[1]);
  unsigned int global_run_enable = std::atoi (argv[2]);

  if (prescale_ls < 1 || prescale_ls > 4095) {
    std::cerr << "wrong prescale factor " << prescale_ls << std::endl;
    std::cerr << "usage: ut_ctl prescale_ls(1-4095)" << std::endl;
    exit (1);
  }

  if (global_run_enable != 0 && global_run_enable != 1) {
    std::cerr << "wrong global_run_enable " << global_run_enable << std::endl;
    std::cerr << "usage: ut_ctl prescale_ls(1-4095) global_run_enable(0/1)" << std::endl;
    exit (1);
  }
  global_run_enable = global_run_enable ? 1 : 0;

  detail::caen_io io(cvA32_U_DATA, cvD32, 0x02000000, "PCIE", 0, 0);

  int old = io.read_register (0x101C);
  io.write_register (0x101c, (1UL << 16) | (prescale_ls & 0xFFFF));

  io.write_register (0x1018, 1 | (1UL << 7) | (3UL << 8) | (global_run_enable << 3));

  std::cout << "Veto FanOut in local mode with LS prescale of " << prescale_ls << " (old is " << (old & 0xFFFF) << ")" << std::endl;

  return 0;
}


